//
//  NSString+Extension.h
//  FMNewProject
//
//  Created by LBS_ios1 on 2017/12/28.
//  Copyright © 2017年 http://www.jianshu.com/u/8acc5c21e350. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NSString (Extension)

/**
 返回文字具体占据的实际的大小

 @param purposeSize 估算的大小
 @param font 字体
 @return 返回实际的文字的大小
 */
- (CGSize)targetSizeForTextWithpurposeSize:(CGSize)purposeSize WithTextFont:(UIFont *)font;

/**
 将总秒数转化成时分秒字符串
 */
+ (instancetype)timeFormatted:(NSInteger)totalSeconds;
/**
 将第三方跑步的总秒数转化成时分秒字符串
 */
+ (instancetype)thirdRunDataHoursFormatted:(NSInteger)totalSeconds;
/**
 将总秒数转化成时分秒字符串
 */
+ (instancetype)hoursFormatted:(NSInteger)totalSeconds;
/**
 将总秒数转化成分秒字符串
 */
+ (instancetype)minuteTimeFormatted:(NSInteger)totalSeconds;

/**
 使用MD5 进行小写加密方法
 */
+ (NSString *) md5:(NSString *) str;

/**
  使用MD5大写加密
 */
- (NSString*)md532BitUpper;

/**
 得道指定文件的大小（文件的所占的字节数） 
 */
- (long long) getFileSize;
/**
 获取时间的秒数
 */
- (NSInteger) getTimeSeconds;

@end
