//
//  FMHeaderNewScrollView.m
//  FMNewProject
//
//  Created by LBS_ios1 on 2017/12/28.
//  Copyright © 2017年 http://www.jianshu.com/u/8acc5c21e350. All rights reserved.
//

#import "FMHeaderNewScrollView.h"
@interface FMHeaderNewScrollView()


@property(nonatomic,strong)NSMutableArray *dataArray;
@property(nonatomic ,strong)UIView *lineView;
@property(nonatomic ,strong)UIButton *selectButton;

@end

@implementation FMHeaderNewScrollView

-(instancetype)initWithFrame:(CGRect)frame
{
    self=[super initWithFrame:frame];
    if (self)
    {
        
        
        [self creatShowSelectButton];
        
        [self addSubview:self.lineView];
    }
    return self;
}

#pragma mark === lineView
-(UIView *)lineView
{
    if (!_lineView) {
        _lineView=[[UIView alloc]init];
        _lineView.backgroundColor=[UIColor redColor];
        _lineView.frame=CGRectMake(0, self.YHheight-3, YHScreenWith/6, 2);
    }
    
    return _lineView;
}

-(void)creatShowSelectButton
{
    [self showButtonWithTitle:@"一" ButtonType:showSelectButtonType_one];
    [self showButtonWithTitle:@"二" ButtonType:showSelectButtonType_two];
    [self showButtonWithTitle:@"三" ButtonType:showSelectButtonType_third];
    [self showButtonWithTitle:@"四" ButtonType:showSelectButtonType_forth];
    [self showButtonWithTitle:@"五" ButtonType:showSelectButtonType_five];
    [self showButtonWithTitle:@"六" ButtonType:showSelectButtonType_six];
    
    
    
}

-(void)showButtonWithTitle:(NSString *)title ButtonType:(showSelectButtonType )type
{
    UIButton *button=[UIButton buttonWithType:UIButtonTypeCustom];
    
    [button setTitle:title forState:UIControlStateNormal];
    [button setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
    [button addTarget:self action:@selector(onButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    button.tag=type;
    
    button.titleLabel.font=[UIFont systemFontOfSize:15];
    button.titleLabel.textAlignment =NSTextAlignmentCenter;
    
    if (type==showSelectButtonType_one)
    {
        [button setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
        self.selectButton=button;
    }
    
    
    [self addSubview:button];
    
    [self.dataArray addObject:button];
    
}

-(void)onButtonClick:(UIButton *)button
{
    
    if (self.delegate && [self.delegate respondsToSelector:@selector(selectShowButtonWith:)]) {
        [self.delegate selectShowButtonWith:button.tag];
    }
    
    [UIView animateWithDuration:0.1 animations:^{
        self.lineView.x = button.x;
        
    }];
    
    
    if (self.selectButton != button) {
        [button setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
        
        [self.selectButton setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
        
        self.selectButton= button;
    }
    
    
    //    self.lineView.frame=CGRectMake(YHScreenWith/6*button.tag, 48, YHScreenWith/6, 1);
    
}
-(void)setInteger:(NSInteger)integer
{
    _integer=integer;
    
    UIButton *button=self.dataArray[integer];
    //    self.lineView.frame=CGRectMake(YHScreenWith/6*integer, 48, YHScreenWith/6, 1);
    [UIView animateWithDuration:0.1 animations:^{
        self.lineView.x = button.x;
        
    }];
    
    
    if (self.selectButton != button) {
        [button setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
        
        [self.selectButton setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
        
        self.selectButton= button;
    }
    
    
}

-(NSMutableArray *)dataArray
{
    if (!_dataArray) {
        _dataArray=[[NSMutableArray alloc]init];
    }
    return _dataArray;
}
-(void)layoutSubviews
{
    for (int i =0; i<self.dataArray.count; i++) {
        
        UIButton *button=self.dataArray[i];
        
        
        button.frame=CGRectMake( i * YHScreenWith/self.dataArray.count , 0, YHScreenWith/self.dataArray.count, self.YHheight);
        
        
    }
    
    
    //    for (UIButton *button in self.dataArray) {
    //        button.frame
    //    }
    //
    
    
}




@end
