//
//  FMHeaderTitleView.m
//  FMNewProject
//
//  Created by LBS_ios1 on 2017/12/28.
//  Copyright © 2017年 http://www.jianshu.com/u/8acc5c21e350. All rights reserved.
//
#import "FMHeaderTitleView.h"
#import "FMCoustomCollectionViewCell.h"
@interface FMHeaderTitleView()<UICollectionViewDelegate,UICollectionViewDataSource>

@property(nonatomic,strong)UICollectionView *collectionView;


@property(nonatomic,strong)NSMutableArray *itemWidthArray;

@property(nonatomic,assign)NSInteger redIndex;
@property(nonatomic,strong) FMCoustomCollectionViewCell *SelectedCell;
@property(nonatomic,strong) UIView *lineView;
@property(nonatomic,strong)NSMutableArray *itemCellXArray;

@end


@implementation FMHeaderTitleView

-(instancetype)initWithFrame:(CGRect)frame
{
    if (self=[super initWithFrame:frame]) {
        
        
        self.redIndex=0;

        [self addSubview:self.collectionView];
        [self.collectionView addSubview:self.lineView];
       
        
    }
    return self;
}
-(NSMutableArray *)itemWidthArray
{
    if (!_itemWidthArray)
    {
        _itemWidthArray =[[NSMutableArray alloc]init];
    }
    return _itemWidthArray;
}

-(UIView *)lineView
{
    if (!_lineView) {
        _lineView=[[UIView alloc]init];
        _lineView.backgroundColor=[UIColor redColor];
        
       
        
    }
    return _lineView;
}
-(NSMutableArray *)itemCellXArray
{
    if (!_itemCellXArray) {
        _itemCellXArray=[[NSMutableArray alloc]init];
        
    }
    return _itemCellXArray;
}

-(void)setItemsArray:(NSArray *)itemsArray
{
    _itemsArray=itemsArray;
    
    CGFloat cellX=YHScreenWith/2 -  [self.itemWidthArray.firstObject floatValue] / 2;
    for (int i=0; i<itemsArray.count; i++)
    {
        
        NSString *item=itemsArray[i];
        
        
        CGFloat Width =[item  targetSizeForTextWithpurposeSize:CGSizeMake(MAXFLOAT, self.YHheight) WithTextFont:[UIFont systemFontOfSize:15]].width+20;//计算出每一个字符串的宽度
        CGFloat cellMix= cellX;
        [self.itemCellXArray addObject:@(cellMix)];
        cellX =cellX+Width;
        [self.itemWidthArray addObject:@(Width)];
    }
    
}

-(void)setInteger:(NSInteger)integer
{
    _integer=integer;
    
    [self updateSliderLinePosition:integer];
    
    self.redIndex = integer;
    [self.collectionView scrollToItemAtIndexPath:[NSIndexPath indexPathForItem:integer inSection:0] atScrollPosition:UICollectionViewScrollPositionCenteredHorizontally animated:YES];
    [self.collectionView reloadData];
    
}


-(UICollectionView *)collectionView
{
    if (!_collectionView) {
        
        UICollectionViewFlowLayout *flowlayout=[[UICollectionViewFlowLayout alloc]init];
        flowlayout.minimumLineSpacing=0;
        flowlayout.minimumInteritemSpacing=0;
        flowlayout.scrollDirection = UICollectionViewScrollDirectionHorizontal;
        flowlayout.sectionInset = UIEdgeInsetsMake(0, YHScreenWith/2 -  [self.itemWidthArray.firstObject floatValue] / 2, 0, YHScreenWith / 2 -  [self.itemWidthArray.lastObject floatValue] / 2);

        _collectionView=[[UICollectionView alloc]initWithFrame:self.bounds collectionViewLayout:flowlayout];
        _collectionView.delegate=self;
        _collectionView.dataSource=self;
        _collectionView.showsVerticalScrollIndicator=YES;
        _collectionView.backgroundColor=[UIColor whiteColor];
        [_collectionView registerClass:[FMCoustomCollectionViewCell class] forCellWithReuseIdentifier:@"FMCoustomCollectionViewCell"];
    }
    
    return _collectionView;
}
-(NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section
{
    return self.itemsArray.count;
    
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView
                  cellForItemAtIndexPath:(NSIndexPath *)indexPath
{
    FMCoustomCollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"FMCoustomCollectionViewCell" forIndexPath:indexPath];
//    cell.index = indexPath.row;
    if (indexPath.row == self.redIndex) {
        cell.titleLable.textColor = [UIColor redColor];
        
        self.SelectedCell=cell;
    }
    else{
        cell.titleLable.textColor = [UIColor grayColor];
    }
    
    
    cell.titleLable.text=self.itemsArray[indexPath.row];
    return cell;
}

- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath{
    //100;//
    CGFloat width = [self.itemWidthArray[indexPath.row] floatValue];
    
    
//    NSLog(@"======== %@",self.itemWidthArray);
    
    return CGSizeMake(width, 60);
}
-(void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath
{
    
    FMCoustomCollectionViewCell *cell = (FMCoustomCollectionViewCell *)[collectionView cellForItemAtIndexPath:indexPath];
    
    if (![self.SelectedCell isEqual:cell]) {
        cell.titleLable.textColor = [UIColor redColor];
        self.SelectedCell.titleLable.textColor = [UIColor grayColor];
        self.SelectedCell=cell;
    }
    
    
    self.redIndex = indexPath.row;
    
    
    [self updateSliderLinePosition:indexPath.row];

    
//    //标题居中
    CGFloat offsetX = collectionView.contentOffset.x;

    CGFloat maginSpace = offsetX + ([UIScreen mainScreen].bounds.size.width/2);
    CGFloat minSpace = cell.center.x - maginSpace;
    [self.collectionView setContentOffset:CGPointMake(offsetX + minSpace, 0) animated:YES];

    if (self.delegate && [self.delegate respondsToSelector:@selector(selectTitleViewWith:)]) {
        
        [self.delegate selectTitleViewWith:indexPath.row];
        
    }
   
    
}




#pragma mark ---- 处理数据滚动情况 标题居中
- (void)scrollViewDidEndDragging:(UIScrollView *)scrollView willDecelerate:(BOOL)decelerate {



    if (!decelerate)
    {
        [self changeItemLocationWithScrollview:scrollView];

    }
}
- (void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView {


    [self changeItemLocationWithScrollview:scrollView];
}

#pragma mark ============ 改变item的位置
- (void)changeItemLocationWithScrollview:(UIScrollView *)scrollView {
    NSArray *arrCell = self.collectionView.visibleCells;
    FMCoustomCollectionViewCell *cell1 = arrCell.firstObject;
    CGFloat offsetX = scrollView.contentOffset.x;
    CGFloat maginSpace = offsetX + ([UIScreen mainScreen].bounds.size.width/2);
    CGFloat minSpace = cell1.center.x - maginSpace;
    if (minSpace < 0) {
        minSpace = 0 - minSpace;
    }
    for (int i = 1; i < arrCell.count; i++) {
        FMCoustomCollectionViewCell *cell = arrCell[i];
        CGFloat space = cell.center.x - maginSpace;
        if (space < 0) {
            space = 0 - space;
        }
        if (space < minSpace) {
            minSpace = space;
            cell1 = cell;
        }
        
    }
    minSpace = cell1.center.x - maginSpace;
    
    [self.collectionView setContentOffset:CGPointMake(offsetX + minSpace, 0) animated:YES];
    NSIndexPath *indexPath = [self.collectionView indexPathForCell:cell1];
    
    
    
//    FMCoustomCollectionViewCell *cell = (FMCoustomCollectionViewCell *)[collectionView cellForItemAtIndexPath:indexPath];
    
    if (![self.SelectedCell isEqual:cell1]) {
        cell1.titleLable.textColor = [UIColor redColor];
        self.SelectedCell.titleLable.textColor = [UIColor grayColor];
        self.SelectedCell=cell1;
    }
    
    
    self.redIndex = indexPath.row;
    
    [self updateSliderLinePosition:indexPath.row];
    
    if (self.delegate && [self.delegate respondsToSelector:@selector(selectTitleViewWith:)]) {
        
        [self.delegate selectTitleViewWith:indexPath.row];
        
    }
    
    //刷新
    [self.collectionView reloadData];
    
}





/**
 *  更新下划线位置
 *
 *  @param index 当前位置
 */
- (void)updateSliderLinePosition:(NSInteger)index {
    
    CGFloat cellMinX=[self.itemCellXArray[index] floatValue];
    [self.lineView mas_updateConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(cellMinX);
        make.width.mas_equalTo([self.itemWidthArray[index] floatValue]);
    }];
}


-(void)layoutSubviews{
    
    [self.lineView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.height.mas_equalTo(2);
        make.bottom.mas_equalTo(self);
        make.left.mas_equalTo([self.itemCellXArray.firstObject floatValue]);
        make.width.mas_equalTo([self.itemWidthArray.firstObject floatValue]);
    }];
}












































































/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
