//
//  FMTwoScrollViewViewController.m
//  FMNewProject
//
//  Created by LBS_ios1 on 2017/12/28.
//  Copyright © 2017年 http://www.jianshu.com/u/8acc5c21e350. All rights reserved.
//

#import "FMTwoScrollViewViewController.h"

@interface FMTwoScrollViewViewController ()<UIScrollViewDelegate,FMHeaderTitleViewDelegate>
@property(nonatomic,strong)FMHeaderTitleView *titleView;
@property(nonatomic,strong)NSArray * itemArray;
@property(nonatomic,strong)UIScrollView *scrollView;

@property(nonatomic,strong)FMOneViewController *OneView;

@end

@implementation FMTwoScrollViewViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.view.backgroundColor=[UIColor whiteColor];
    
    self.title=@"新闻标题中心滑动";
    
    self.itemArray =@[@"家电1", @"大家电2", @"小家电3", @"厨房电器4", @"生活用品5",@"家电6",@"家电7", @"大家电8", @"小家电9", @"厨房电器厨房电器10", @"生活用品11",@"家电12",@"家电13", @"大家电14", @"小家电15", @"厨房电器16", @"生活用品17",@"家电18"];
    
    [self.view addSubview:self.titleView];
    
    self.titleView.itemsArray=self.itemArray;
    
    [self.view addSubview:self.scrollView];
    
}
#pragma mark ==== FMHeaderTitleView
-(FMHeaderTitleView *)titleView
{
    if (!_titleView) {
        _titleView=[[FMHeaderTitleView alloc]initWithFrame:CGRectMake(0, 64, YHScreenWith, 60)];
        _titleView.backgroundColor=[UIColor greenColor];
        _titleView.delegate=self;
    }
    return _titleView;
}
#pragma mark ===== FMHeaderTitleView代理
-(void)selectTitleViewWith:(NSInteger)interger
{
    self.scrollView.contentOffset=CGPointMake(YHScreenWith*interger, 0);
    [self setShowScrollViewControllerWith:interger];
    
}


#pragma mark ====
-(FMOneViewController *)OneView
{
    if (!_OneView) {
        _OneView=[[FMOneViewController alloc]init];
        _OneView.view.frame=CGRectMake(0, 0, YHScreenWith, self.scrollView.YHheight);
    }
    
    return _OneView;
}


-(UIScrollView *)scrollView
{
    if (!_scrollView) {
        _scrollView=[[UIScrollView alloc]init];
        _scrollView.frame=CGRectMake(0, CGRectGetMaxY(self.titleView.frame), YHScreenWith, YHScreenHeight-CGRectGetMaxY(self.titleView.frame));
        
        
        _scrollView.contentSize=CGSizeMake(YHScreenWith*self.itemArray.count, 0);
        
        _scrollView.delegate=self;
        _scrollView.bounces = NO;
        _scrollView.backgroundColor=[UIColor yellowColor];
        _scrollView.pagingEnabled=YES;
        _scrollView.showsHorizontalScrollIndicator=NO;
        
        
        [_scrollView addSubview:self.OneView.view];
        [self addChildViewController:self.OneView];
        
    }
    return _scrollView;
}
-(void)scrollViewDidScroll:(UIScrollView *)scrollView
{
    
}

-(void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView
{
    
    
    if (scrollView == self.scrollView) {
        NSInteger index=scrollView.contentOffset.x/YHScreenWith;
        
        [self setShowScrollViewControllerWith:index];
        
        self.titleView.integer=index;
    }
}

-(void)setShowScrollViewControllerWith:(NSInteger )type
{
    
    self.OneView.title=self.itemArray[type];
    
    [[NSNotificationCenter defaultCenter]postNotificationName:@"name" object:self.itemArray[type]];
    
    
    [self addControllViews:self.OneView];
    
    
    self.OneView.view.frame=CGRectMake(YHScreenWith*type, 0, YHScreenWith, self.scrollView.YHheight);
    
    //
    //    switch (type) {
    //        case 0:
    //            [self addControllViews:self.OneView];
    //
    //            break;
    //        case 1:
    //            [self addControllViews:self.TwoView];
    //
    //            break;
    //        case 2:
    //            [self addControllViews:self.ThirdView];
    //
    //            break;
    //        case 3:
    //            [self addControllViews:self.ForthView];
    //
    //            break;
    //        case 4:
    //            [self addControllViews:self.FiveView];
    //
    //            break;
    //        case 5:
    //            [self addControllViews:self.SixView];
    //            break;
    //        case 6:
    //            [self addControllViews:self.OneView];
    //
    //            break;
    //        case 7:
    //            [self addControllViews:self.TwoView];
    //
    //            break;
    //        case 8:
    //            [self addControllViews:self.ThirdView];
    //
    //            break;
    //        case 9:
    //            [self addControllViews:self.ForthView];
    //
    //            break;
    //        case 10:
    //            [self addControllViews:self.FiveView];
    //
    //            break;
    //        case 11:
    //            [self addControllViews:self.SixView];
    //            break;
    //        case 12:
    //            [self addControllViews:self.ThirdView];
    //
    //            break;
    //        case 13:
    //            [self addControllViews:self.ForthView];
    //
    //            break;
    //        case 14:
    //            [self addControllViews:self.FiveView];
    //
    //            break;
    //        case 15:
    //            [self addControllViews:self.SixView];
    //            break;
    //        case 16:
    //            [self addControllViews:self.OneView];
    //
    //            break;
    //        case 17:
    //            [self addControllViews:self.TwoView];
    //
    //            break;
    //        case 18:
    //            [self addControllViews:self.ThirdView];
    //
    //            break;
    //        case 19:
    //            [self addControllViews:self.ForthView];
    //
    //            break;
    //        default:
    //            break;
    //    }
    
    
}

#pragma mark ==== 添加视图控制器上的view
- (void)addControllViews:(UIViewController *)VC
{
    if (!VC.view.superview) {
        [self.scrollView addSubview:VC.view];
        
        
        [self addChildViewController:VC];
    }
}



- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
